import { ResourceAutoNaming, ResourceDefaultNaming, ResourceNamingType as RDSDatabaseAutoRunningProtectionStackResourceNamingType } from '@gammarers/aws-resource-naming';
import { Stack, StackProps } from 'aws-cdk-lib';
import * as sfn from 'aws-cdk-lib/aws-stepfunctions';
import { Construct } from 'constructs';
export { RDSDatabaseAutoRunningProtectionStackResourceNamingType };
export interface TargetResource {
    readonly tagKey: string;
    readonly tagValues: string[];
}
export interface Slack {
    readonly webhookSecretName: string;
}
export interface Notifications {
    readonly emails?: string[];
    readonly slack?: Slack;
}
export type MachineLogLevel = sfn.LogLevel;
export interface LogOption {
    readonly machineLogLevel?: MachineLogLevel;
}
export interface RDSDatabaseAutoRunningProtectionStackProps extends StackProps {
    readonly targetResource: TargetResource;
    readonly enableRule?: boolean;
    readonly notifications?: Notifications;
    readonly resourceNamingOption?: ResourceNamingOption;
    readonly logOption?: LogOption;
}
export interface ResourceCustomNaming {
    readonly type: RDSDatabaseAutoRunningProtectionStackResourceNamingType.CUSTOM;
    readonly stateMachineName: string;
    readonly stateMachineRoleName: string;
    readonly startEventCatchRuleRoleName: string;
    readonly startInstanceEventCatchRuleName: string;
    readonly startClusterEventCatchRuleName: string;
}
export type ResourceNamingOption = ResourceDefaultNaming | ResourceAutoNaming | ResourceCustomNaming;
export declare class RDSDatabaseAutoRunningProtectionStack extends Stack {
    constructor(scope: Construct, id: string, props: RDSDatabaseAutoRunningProtectionStackProps);
}
